import com.bluedust.utils.*;
import java.io.*;

/**
 * A simple class to verify the workings of the BitInputStream and
 * BitOutputStream classes.
 * 
 * @author steev
 *
 */
public class TestBitStream {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		byte[] data={(byte)0xc6,0x52,0x65};
		// 11000110 01010010 01100101
		// 1 10 001 1001010 01001100 101
		// 1 2  1   74      75       5
		ByteArrayInputStream bais = new ByteArrayInputStream(data);
		DataInputStream ds = new DataInputStream(bais);
		BitInputStream bs = new BitInputStream(ds);

		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		DataOutputStream dos = new DataOutputStream(baos);
		BitOutputStream bso = new BitOutputStream(dos);

		try {
			System.out.println("read "+ bs.getBits(1));
			System.out.println("read "+ bs.getBits(2));
			System.out.println("read "+ bs.getBits(3));
			System.out.println("read "+ bs.getBits(7));
			System.out.println("read "+ bs.getBits(8));
			System.out.println("read "+ bs.getBits(3));
			
			bso.putBits(1, 1);
			bso.putBits(2, 2);
			bso.putBits(1, 3);
			bso.putBits(74, 7);
			bso.putBits(76, 8);
			bso.putBits(5, 3);
			bso.flushToByte();
			
			byte[] b = baos.toByteArray();
			for(int i=0;i<b.length;++i) {
				System.out.println("["+i+"] = "+b[i]+"  ("+Numerics.binString(b[i], 8)+"b)");
			}
			
		} catch (java.io.IOException e) {
			System.err.println("Could not read file. "+e.getMessage());
		} catch (Exception e) {
			System.err.println("General exception "+e.getMessage());
		}
	}
	
}
